#!/usr/bin/env python
# coding: utf-8

# In[74]:


import json
import pandas as pd
import numpy as np
import glob
import sys
import datetime


# In[80]:


import zipfile


# In[83]:

input_file=sys.argv[1]
output_file=sys.argv[2]


# In[84]:


#list_articles=glob.glob("tmp/*/*.json")


# In[85]:


output=[]
with zipfile.ZipFile(input_file, 'r') as zip_ref:
    for file in zip_ref.namelist():
        if file.split('.')[1] != 'json' or file.split('.')[0] == 'manifest':
            continue
        try:
            article=json.load(zip_ref.open(file))

            temp={}
            temp["title"]=article.get("title","").encode(encoding = 'UTF-8', errors = 'ignore').decode("utf-8").replace("\t", " ")
            temp["abstract"]=article.get("abstract","").encode(encoding = 'UTF-8', errors = 'ignore').decode("utf-8").replace("\t", " ")

            authors=""
            for author in article.get("author",[]):
                authors+=author["name"]+", "
            authors=authors[:-2]

            temp["code"] = article.get("_id")
            temp["authors"]=authors.encode(encoding = 'UTF-8', errors = 'ignore').decode("utf-8").replace("\t", " ").replace(",", ";")
            temp["source"]=article["host"]["title"].encode(encoding = 'UTF-8', errors = 'ignore').decode("utf-8").replace("\t", " ")
            temp["publication_year"]=article.get("publicationDate", datetime.date.today().year)
            temp["publication_month"]=1
            temp["publication_day"]=1
            

            output.append(temp)
        except Exception as e:
            print(file,e)


# In[86]:


output=pd.DataFrame(output)
tmp = output.size
duplicated = output['title'].str.lower().replace(",", "", regex=True).duplicated()

if (duplicated.any()):
    print("\nQuelques fichiers n'ont pas été introduits dans le TSV car ils pourraient apparaitre plusieurs fois:")
    for i in range(0, output["title"].size - 1):
        if (duplicated[i]):
            print("\t" + output["code"][i] + " " + output["title"][i])
output.drop(['code'], axis=1)
output = output[~duplicated]

# In[87]:


output.to_csv(output_file,sep='\t',index=False)
print("")


# In[ ]:
